var de = Object.defineProperty;
var ue = (s, e, a) => e in s ? de(s, e, { enumerable: !0, configurable: !0, writable: !0, value: a }) : s[e] = a;
var C = (s, e, a) => (ue(s, typeof e != "symbol" ? e + "" : e, a), a);
import { EditFormModel as me, FormMDCtrlModel as pe, DefectModelError as he, AppEntityModel as G } from "@ibiz-template/model";
import { useNamespace as B, useControlController as fe, usePropsWatch as ve, getDatePickerProps as ye, getEditorEmits as H, useController as ge, getDataPickerProps as te } from "@ibiz-template/vue-util";
import { defineComponent as _, getCurrentInstance as ae, ref as b, watch as L, h as r, onMounted as De, computed as V } from "vue";
import { createUUID as Q } from "qx-util";
import { ViewMode as ee, PluginStaticResource as Ee, UIActionHandler as Ce, FrontUIActionHandler as se, OpenAppViewCommand as re } from "@ibiz-template/runtime";
import { EditFormController as be, FormMDCtrlController as we, FormDRUIPartController as Pe, DatePickerEditorController as Ae, UploadEditorController as Fe, PickerEditorController as oe } from "@ibiz-template/controller";
import { ControlVO as Ie, calcResPath as q } from "@ibiz-template/service";
import $ from "dayjs";
import { StringUtil as ne } from "@ibiz-template/core";
class ke extends be {
  constructor() {
    super(...arguments);
    /**
     *   基础数据
     *
     * @author fangZhiHao
     * @date 2024-04-26 17:04:49
     * @type {IData}
     */
    C(this, "baseResData", []);
    /**
     *   对比数据
     *
     * @author fangZhiHao
     * @date 2024-04-26 17:04:49
     * @type {IData}
     */
    C(this, "compareResData", []);
    /**
     * 表单旧数据
     *
     * @author zk
     * @date 2023-12-20 11:12:43
     * @protected
     * @type {IData}
     * @memberof FormController
     */
    C(this, "oldData", new Ie());
    /**
     * version数据
     *
     * @author fangZhiHao
     * @date 2024-04-26 16:04:37
     * @type {IData[]}
     */
    C(this, "versionData", []);
    /**
     *  对比数据
     *
     * @author fangZhiHao
     * @date 2024-04-26 16:04:37
     * @type {IData[]}
     */
    C(this, "comparisonArr", {});
    /**
     *  基础表格数据
     *
     * @author fangZhiHao
     * @date 2024-05-06 11:05:57
     * @type {IData[]}
     */
    C(this, "gridData", []);
    /**
     *  展示完全数据
     *
     * @author fangZhiHao
     * @date 2024-05-06 11:05:04
     * @type {IData[]}
     */
    C(this, "AllGridData", []);
    /**
     *  去除相同数据
     *
     * @author fangZhiHao
     * @date 2024-05-06 11:05:15
     * @type {IData[]}
     */
    C(this, "removeSameGridData", []);
    /**
     *  关系界面数据
     *
     * @author fangZhiHao
     * @date 2024-04-30 10:04:33
     * @type {IData}
     */
    C(this, "AlldruipartData", /* @__PURE__ */ new Map());
    /**
     *  关系界面数据长度
     *
     * @author fangZhiHao
     * @date 2024-05-06 11:05:56
     * @type {number}
     */
    C(this, "druipartDataSize", 0);
    /**
     *   关系界面实际数据
     *
     * @author fangZhiHao
     * @date 2024-05-06 11:05:13
     * @type {IData}
     */
    C(this, "newDruipartData", {});
  }
  /**
   * 加载数据
   *
   * @return {*}  {Promise<ControlVO>}
   * @memberof FormDataComparisonController
   */
  async loadGridData() {
    await this.startLoading();
    const a = this.model.source.M.getPSControlParam.ctrlParams, { BASEENTITY: t, COMPAREENTITY: l } = a, n = await ibiz.entityService.getService(t), c = await ibiz.entityService.getService(l), g = Object.assign({}, this.context.clone(), {
      [t.toLowerCase()]: this.params.base_version
    }), p = Object.assign({}, this.context.clone(), {
      [l.toLowerCase()]: this.params.compare_version
    }), f = await n.exec("Get", g, this.params), y = await c.exec(
      "Get",
      p,
      this.params
    );
    return this.isLoaded = !0, {
      baseData: f.data.data,
      compareData: y.data.data
    };
  }
  /**
   * 判断值是否为空
   *
   * @param {(string | IData[] | null | undefined)} value
   * @return {*}
   * @memberof FormDataComparisonController
   */
  isFalseyButNotEmpty(a) {
    return a == null || typeof a == "string" && a === "" || Array.isArray(a) && a.length === 0 || typeof a == "object" && Object.keys(a).length === 0;
  }
  /**
   * 比较两个值
   *
   * @param {IData} objA
   * @param {IData} objB
   * @return {*}
   * @memberof FormDataComparisonController
   */
  compareObjectValues(a, t) {
    return JSON.stringify(a) !== JSON.stringify(t);
  }
}
const Se = _({
  name: "IBizFormDataComparison",
  props: {
    modelData: {
      type: me,
      required: !0
    },
    context: {
      type: Object,
      required: !0
    },
    params: {
      type: Object,
      default: () => ({})
    },
    enableAutoSave: {
      type: Boolean,
      required: !1
    }
  },
  setup(s) {
    const e = B("form-data-comparison"), {
      proxy: a
    } = ae(), t = fe(a, () => {
      const o = new ke(s.modelData, s.context, s.params);
      return ve(a, "enableAutoSave", o.setEnableAutoSave.bind(o)), o;
    }), l = b(!0), n = b(!1), c = b({}), g = b({}), p = b([]), f = [], y = b([]), i = b([]), v = b([]), h = /* @__PURE__ */ new Map(), u = b(0), m = (o) => {
      const d = [];
      if (d.push(o), o && o.children) {
        const A = [];
        o.children.forEach((F) => {
          const O = m(F);
          A.push(...O);
        }), d.push(...A);
      }
      return d;
    }, E = m(s.modelData);
    f.push(...E);
    const P = (o) => {
      const d = t.details[o.source.name], A = r("not-supported-editor", {
        attrs: {
          modelData: o.editor
        }
      });
      return r("div", {
        class: [e.e("form-grid-item"), e.is("add", y.value.includes(o.source.name)), e.is("update", v.value.includes(o.source.name)), e.is("delete", i.value.includes(o.source.name))]
      }, [r("div", {
        class: e.em("form-grid-item", "name")
      }, [o.source.caption]), r("div", {
        class: e.em("form-grid-item", "left")
      }, [d.editorProvider ? r(d.editorProvider.formEditor, {
        props: {
          value: g.value[o.source.name],
          data: d.data,
          controller: d.editor,
          disabled: d.disabled,
          readonly: !0
        }
      }) : A]), r("div", {
        class: e.em("form-grid-item", "right")
      }, [d.editorProvider ? r(d.editorProvider.formEditor, {
        props: {
          value: c.value[o.source.name],
          data: d.data,
          controller: d.editor,
          disabled: d.disabled,
          readonly: !0
        }
      }) : A])]);
    }, S = (o, d) => {
      h.set(o.source.id, d), d.evt.on("mounted", () => {
        l.value && t.startLoading(), u.value += 1, d.call.refresh();
      }), d.evt.on("refreshed", () => {
        u.value -= 1, setTimeout(() => {
          l.value && t.endLoading();
        }, 500);
      });
    }, D = (o) => {
      const d = f.find((U) => U.id === `${o.source.id}_srfcopy`), A = o.embedView.source.modelPath, F = d == null ? void 0 : d.embedView.source.modelPath, O = t.context.clone(), N = {
        base_version: s.params.base_version
      }, T = t.context.clone();
      Object.assign(T, {
        gysrlzy_info: s.params.compare_version,
        compare_version: s.params.compare_version
      });
      const j = {
        compare_version: s.params.compare_version
      }, M = c.value[o.source.userTag], R = g.value[d == null ? void 0 : d.source.userTag];
      let K = !1, Y = !1, J = !1;
      if (o.source.userTag2) {
        const U = JSON.parse(o.source.userTag2), {
          comparekey: X,
          comparelist: ce
        } = U;
        M && R && Array.isArray(M) && Array.isArray(R) && (M.length === 0 && R.length !== 0 ? J = !0 : M.length !== 0 && R.length === 0 ? K = !0 : M.length !== 0 && R.length !== 0 && (M.length !== R.length ? Y = !0 : M.some((W) => {
          const Z = R.find((z) => W[X] === z[X]);
          return Z ? ce.some((z) => W[z] !== Z[z] ? (Y = !0, !0) : !1) : (Y = !0, !0);
        })));
      }
      return r("div", {
        class: [e.e("druipart"), e.is("add", K), e.is("update", Y), e.is("delete", J)]
      }, [r("div", {
        class: e.em("druipart", "caption")
      }, [o.source.caption]), r("div", {
        class: e.em("druipart", "left")
      }, [F && r("ViewShell", {
        attrs: {
          context: T,
          params: j,
          modal: {
            mode: ee.EMBED
          },
          modelPath: F,
          noLoadDefault: !0,
          name: d == null ? void 0 : d.source.id
        },
        key: Q(),
        on: {
          neuronInit: (U) => S(d, U)
        }
      })]), r("div", {
        class: e.em("druipart", "right")
      }, [A && r("ViewShell", {
        attrs: {
          context: O,
          params: N,
          modal: {
            mode: ee.EMBED
          },
          modelPath: A,
          noLoadDefault: !0,
          name: o.source.id
        },
        key: Q(),
        on: {
          neuronInit: (U) => S(o, U)
        }
      })])]);
    }, w = (o) => {
      const d = {
        modelData: o,
        controller: t.details[o.source.name]
      }, A = t.providers[o.source.name], F = r(A.component, {
        props: {
          ...d
        },
        key: o.id
      }), O = r(A.component, {
        props: {
          ...d
        },
        key: `compare_${o.id}`
      });
      return r("div", {
        class: e.e("mdctrl")
      }, [r("div", {
        class: e.em("mdctrl", "caption")
      }, [o.source.caption]), r("div", {
        class: e.em("mdctrl", "left")
      }, [F]), r("div", {
        class: e.em("mdctrl", "right")
      }, [O])]);
    }, I = (o) => {
      l.value = !1;
      const d = p.value.findIndex((A) => A === o.source.name);
      d > -1 ? p.value.splice(d, 1) : p.value.push(o.source.name);
    }, x = (o) => {
      if (!o.source.hidden) {
        if (o.source.detailType === "FORMPAGE")
          return r("div", {
            class: e.e("form-page")
          }, [o.children.map((d) => x(d))]);
        if (o.source.detailType === "FORMITEM") {
          const d = y.value.includes(o.source.name), A = i.value.includes(o.source.name), F = v.value.includes(o.source.name);
          return n.value && !d && !A && !F ? null : P(o);
        }
        if (o.source.detailType === "GROUPPANEL") {
          const d = p.value.includes(o.source.name);
          return r("div", {
            class: e.b("group")
          }, [r("div", {
            class: [e.be("group", "header"), e.is("hide-caption", !o.source.showCaption)]
          }, [r("div", {
            class: e.bem("group", "header", "name")
          }, [d ? r("i-icon", {
            class: e.bem("group", "header", "icon"),
            attrs: {
              type: "ios-arrow-forward",
              title: "展开"
            },
            on: {
              click: () => I(o)
            }
          }) : r("i-icon", {
            class: e.bem("group", "header", "icon"),
            attrs: {
              type: "ios-arrow-down",
              title: "收缩"
            },
            on: {
              click: () => I(o)
            }
          }), r("span", {
            class: e.bem("group", "header", "name-text")
          }, [o.source.caption || o.source.title])]), r("div", ["---"]), r("div", ["---"])]), r("div", {
            class: [e.be("group", "content"), e.is("collapse", d)]
          }, [o.children.map((A) => x(A))])]);
        }
        return o.source.detailType === "DRUIPART" && !o.source.name.endsWith("_srfcopy") ? D(o) : o.source.detailType === "MDCTRL" ? w(o) : null;
      }
    }, k = (o, d) => {
      const A = [], F = [], O = [];
      return Object.keys(d).forEach((N) => {
        const T = o[N], j = d[N];
        t.isFalseyButNotEmpty(T) && !t.isFalseyButNotEmpty(j) && A.push(N), !t.isFalseyButNotEmpty(T) && !t.isFalseyButNotEmpty(j) && t.compareObjectValues(T, j) && F.push(N);
      }), Object.keys(o).forEach((N) => {
        if (!Object.prototype.hasOwnProperty.call(d, N) || t.isFalseyButNotEmpty(d[N])) {
          const T = o[N];
          t.isFalseyButNotEmpty(T) || O.push(N);
        }
      }), {
        added: A,
        modified: F,
        deleted: O
      };
    };
    return L(() => s.params, async () => {
      const o = await t.loadGridData();
      c.value = o.baseData, g.value = o.compareData;
      const {
        added: d,
        modified: A,
        deleted: F
      } = k(g.value, c.value);
      y.value = d, v.value = A, i.value = F;
    }, {
      immediate: !0
    }), {
      ns: e,
      c: t,
      switchValue: n,
      druipartNum: u,
      renderEditor: P,
      renderByDetailType: x
    };
  },
  render() {
    return this.c.complete ? r("control-layout", {
      attrs: {
        modelData: this.c.model
      }
    }, [r("div", {
      class: this.ns.b()
    }, [r("div", {
      class: this.ns.e("top")
    }, [r("div", {
      class: this.ns.e("top-hidesame-content")
    }, [r("div", {
      class: this.ns.e("top-hidesame-content-left")
    }, ["隐藏相同项 ", r("i-switch", {
      model: {
        value: this.switchValue,
        callback: (s) => {
          this.switchValue = s;
        }
      }
    })]), r("div", {
      class: this.ns.e("top-hidesame-content-right")
    }, [r("div", {
      class: this.ns.e("top-hidesame-content-right-item")
    }, ["新增", r("div", {
      class: this.ns.e("top-hidesame-content-right-item-add")
    })]), r("div", {
      class: this.ns.e("top-hidesame-content-right-item")
    }, ["修改", r("div", {
      class: this.ns.e("top-hidesame-content-right-item-change")
    })]), r("div", {
      class: this.ns.e("top-hidesame-content-right-item")
    }, ["删除", r("div", {
      class: this.ns.e("top-hidesame-content-right-item-delete")
    })])])]), r("div", {
      class: this.ns.e("top-content")
    }, [r("div", {
      class: this.ns.em("top-content", "attr")
    }, ["信息项"]), r("div", {
      class: [this.ns.em("top-content", "left")]
    }, ["更新前内容"]), r("div", {
      class: [this.ns.em("top-content", "right")]
    }, ["更新后内容"])])]), r("div", {
      class: this.ns.e("content")
    }, [this.modelData.children.map((s) => this.renderByDetailType(s))])])]) : null;
  }
});
const xe = _({
  name: "CustomDataImport",
  props: {
    templateUrl: {
      type: String,
      required: !0
    },
    importUrl: {
      type: String,
      required: !0
    },
    dismiss: {
      type: Function
    }
  },
  setup(s, {
    emit: e
  }) {
    const a = B("data-import"), t = b(), l = b({
      state: "ready",
      message: "",
      rowError: []
    }), n = b(""), c = async (i) => {
      const v = new FormData(), h = $(n.value).format("YYYY-MM");
      v.append("file", i), v.append("ny", h);
      try {
        const u = await ibiz.net.request(s.importUrl, {
          method: "post",
          data: v,
          headers: {
            "Content-Type": "multipart/form-data"
          }
        });
        l.value.state = "success", l.value.message = "导入成功";
        const {
          errorinfo: m,
          success: E,
          total: P
        } = u.data, S = P ? Number(P) : 0, D = E ? Number(E) : 0, w = P - E;
        l.value.message = `共计导入数据 ${S} 条，错误[${w}]，成功[${D}]`, m && Object.keys(m).length > 0 && (l.value.rowError = [], Object.keys(m).forEach((I) => {
          l.value.rowError.push({
            index: Number(I) + 1,
            info: m[I].errorInfo
          });
        }));
      } catch (u) {
        l.value.state = "fail", l.value.message = `导入失败！${u.message}`;
      }
    }, g = (i) => {
      const v = i.target;
      if (!v.files)
        return;
      const h = v.files[0];
      v.value = null, c(h);
    }, p = async () => {
      var v;
      const i = await ibiz.net.request(s.templateUrl, {
        responseType: "blob"
      });
      if (i.status === 200) {
        let h = ((v = i.headers["content-disposition"].split(";").find((E) => E.indexOf("filename=") !== -1)) == null ? void 0 : v.slice(9)) || "";
        h = decodeURIComponent(h);
        const u = new Blob([i.data], {
          type: "application/vnd.ms-excel"
        }), m = document.createElement("a");
        m.download = h, m.style.display = "none", m.href = URL.createObjectURL(u), document.body.appendChild(m), m.click(), URL.revokeObjectURL(m.href), document.body.removeChild(m);
      }
    }, f = () => {
      t.value.click();
    }, y = () => {
      var i;
      e("close", {
        ok: !1,
        data: {}
      }), (i = s.dismiss) == null || i.call(s, {
        ok: !1,
        data: {}
      });
    };
    return De(() => {
      n.value = $().format("YYYY年MM月");
    }), {
      ns: a,
      curDate: n,
      onLinkClick: p,
      selectFile: f,
      onCancelButtonClick: y,
      onFileChange: g,
      inputUpLoad: t,
      message: l
    };
  },
  render() {
    return r("div", {
      class: [this.ns.b(), this.ns.is("custom", !0)]
    }, [r("input", {
      ref: "inputUpLoad",
      attrs: {
        type: "file",
        accept: "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"
      },
      style: "display: none",
      on: {
        change: this.onFileChange
      }
    }), r("div", {
      class: this.ns.e("caption")
    }, ["导入数据"]), r("div", {
      class: this.ns.e("date")
    }, [r("span", ["导入数据所属月份"]), r("i-datePicker", {
      attrs: {
        format: "yyyy年MM月",
        type: "month",
        clearable: !1
      },
      model: {
        value: this.curDate,
        callback: (s) => {
          this.curDate = s;
        }
      }
    })]), this.message.state === "ready" ? r("div", {
      class: this.ns.b("upload"),
      on: {
        click: this.selectFile
      }
    }, [r("img", {
      class: this.ns.be("upload", "img"),
      attrs: {
        src: "./assets/img/icon-import.svg"
      }
    }), r("span", {
      class: this.ns.be("upload", "text")
    }, ["单击此区域进行上传"])]) : r("div", {
      class: this.ns.b("message")
    }, [r("div", {
      class: this.ns.be("message", "title")
    }, ["导入结果"]), r("div", {
      class: this.ns.be("message", "content")
    }, [this.message.message]), this.message.rowError.length > 0 && [r("div", {
      class: this.ns.be("message", "title")
    }, ["错误信息"]), r("div", {
      class: this.ns.be("message", "content")
    }, [this.message.rowError.map((s) => r("div", [`第 ${s.index} 行：${s.info}`]))])]]), r("div", {
      class: this.ns.e("template-container")
    }, [r("div", {
      class: this.ns.e("template-description")
    }, ["下载导入模版，并按要求填写："]), r("div", {
      class: this.ns.e("template-link"),
      on: {
        click: this.onLinkClick
      }
    }, [r("i-icon", {
      attrs: {
        type: "ios-link"
      }
    }), "数据导入模板文件"])]), r("div", {
      class: this.ns.e("button-bar")
    }, [this.message.state !== "ready" && r("i-button", {
      on: {
        click: this.selectFile
      }
    }, ["重新上传"])])]);
  }
});
const Ne = _({
  name: "YearMonthPicker",
  props: ye(),
  emits: H(),
  setup(s, {
    emit: e
  }) {
    const a = B("date-picker"), t = s.controller, l = t.model, n = b("date"), c = b("yyyy-MM-dd"), g = b(!1);
    switch (l.editorType) {
      case "DATEPICKEREX":
      case "DATEPICKEREX_NOTIME":
        n.value = "date";
        break;
      case "DATEPICKEREX_NODAY":
      case "DATEPICKEREX_NODAY_NOSECOND":
        g.value = !0, n.value = "time";
        break;
      case "DATEPICKEREX_HOUR":
      case "DATEPICKEREX_MINUTE":
      case "DATEPICKEREX_SECOND":
      case "DATEPICKEREX_NOSECOND":
      case "DATEPICKER":
      default:
        n.value = "datetime";
    }
    const p = t.valueFormat;
    if (p) {
      p === "YYYY-MM" ? n.value = "month" : p === "YYYY" && (n.value = "year");
      const h = p.replace("YYYY", "yyyy").replace("DD", "dd");
      c.value = h;
    }
    l.editorParams.formatText && (c.value = l.editorParams.formatText.replace("YYYY", "yyyy").replace("DD", "dd"));
    const f = b();
    L(() => s.value, (h, u) => {
      h && h !== u && (f.value = $(h).format(p));
    }, {
      immediate: !0
    });
    const y = (h, u) => {
      if (h) {
        const m = $(h.replace(/[年月]/g, "-")).format(p);
        e("change", m);
      } else
        e("change", h);
    }, i = (h) => {
      e("operate", h);
    }, v = b();
    return s.autoFocus && L(v, (h) => {
      h && h.$el.getElementsByTagName("input")[0].click();
    }), {
      ns: a,
      c: t,
      editorModel: l,
      type: n,
      format: c,
      formatValue: f,
      handleChange: y,
      onOpenChange: i,
      inputRef: v,
      isTimePicker: g
    };
  },
  render(s) {
    return s("div", {
      class: [this.ns.b(), this.disabled ? this.ns.m("disabled") : "", this.readonly ? this.ns.m("readonly") : ""]
    }, [[this.readonly && this.formatValue, !this.readonly && this.isTimePicker && s("ITimePicker", {
      ref: "inputRef",
      props: {
        ...this.c.customProps,
        value: this.value,
        type: this.type,
        format: this.format,
        placeholder: this.c.placeHolder,
        disabled: this.disabled,
        transfer: !0
      },
      on: {
        "on-change": this.handleChange,
        "on-open-change": this.onOpenChange
      }
    }), !this.readonly && !this.isTimePicker && s("ICalendarPicker", {
      ref: "inputRef",
      props: {
        ...this.c.customProps,
        value: this.value,
        type: this.type,
        format: this.format,
        placeholder: this.c.placeHolder,
        disabled: this.disabled,
        transfer: !0
      },
      on: {
        "on-change": this.handleChange,
        "on-open-change": this.onOpenChange
      }
    })]]);
  }
});
const ie = new Ee(import.meta.url), Oe = _({
  name: "DownLoadSafeFile",
  props: {},
  setup() {
    const s = B("download-safe-file"), e = ie.dir("/assets/doc/safe-file.doc");
    return {
      ns: s,
      url: e
    };
  },
  render() {
    return r("div", {
      class: this.ns.b()
    }, [r("a", {
      attrs: {
        download: "网络信息安全承诺书.doc",
        href: this.url
      }
    }, ["网络信息安全承诺书.doc"])]);
  }
});
class le extends we {
  constructor() {
    super(...arguments);
    /**
     * 激活的分页下标
     *
     * @type {number}
     * @memberof FormMDCtrlFormStyle2Controller
     */
    C(this, "active", 0);
  }
  connect(a, t) {
    this.formNeurons.get(a) || (this.formNeurons.set(a, t), t.evt.on("mounted", () => {
      t.call.load();
    }), t.evt.on("destroyed", () => {
      this.formNeurons.delete(a);
    }), t.evt.on("valueChange", (l) => {
      if (l) {
        const n = this.contentCtrlData.find((c) => c.srfkey === l.srfkey);
        n && Object.assign(n, l), this.force();
      }
    }));
  }
  /**
   * 校验
   *
   * @return {*}  {Promise<boolean>}
   * @memberof FormMDCtrlFormStyle2Controller
   */
  async validate() {
    const a = [];
    this.formNeurons.forEach((n, c) => {
      const g = n.call.getFormController();
      a.push({ key: c, controller: g });
    });
    let t = "";
    const l = await Promise.all(
      a.map(async (n) => {
        const c = await n.controller.validate();
        return !t && !c && (t = n.key), c;
      })
    );
    if (t) {
      const n = this.contentCtrlData.findIndex((c) => c.srfkey === t);
      n > -1 && (this.active = n);
    }
    return l.findIndex((n) => !n) === -1;
  }
  /**
   * 静默校验
   *
   * @return {*}  {Promise<boolean>}
   * @memberof FormMDCtrlFormStyle2Controller
   */
  async silentValidate() {
    const a = [];
    this.formNeurons.forEach((n, c) => {
      const g = n.call.getFormController();
      a.push({ key: c, controller: g });
    });
    let t = "";
    const l = await Promise.all(
      a.map(async (n) => {
        const c = await n.controller.silentValidate();
        return !t && !c && (t = n.key), c;
      })
    );
    if (t) {
      const n = this.contentCtrlData.findIndex((c) => c.srfkey === t);
      n > -1 && (this.active = n);
    }
    return l.findIndex((n) => !n) === -1;
  }
}
const Te = _({
  name: "FormMDCtrlFormStyle2",
  props: {
    controller: {
      type: le,
      required: !0
    },
    modelData: {
      type: pe,
      required: !0
    }
  },
  setup(s) {
    const e = B("form-mdctrl-form-style2"), a = s.controller, {
      proxy: t
    } = ae();
    ge(t, s.controller);
    const l = async (f, y, i) => {
      i.stopPropagation(), i.preventDefault();
      const v = a.contentCtrlData.length;
      await a.handleRemove(f, y), v !== a.contentCtrlData.length && y <= a.active && a.active !== 0 && (a.active -= 1);
    }, n = (f) => {
      a.active = f, a.force();
    }, c = async () => {
      const f = JSON.parse(JSON.stringify(a.contentCtrlData)).length;
      await a.handleAdd(), f < a.contentCtrlData.length && (a.active = a.contentCtrlData.length - 1);
    }, g = () => {
      const f = s.modelData.source.userTag;
      let y = {};
      f && (y = JSON.parse(f));
      const {
        tabtitle: i,
        addtitle: v
      } = y;
      return r("div", {
        class: e.e("header")
      }, [a.contentCtrlData.map((h, u) => {
        let m = `新建${u + 1}`;
        return h.srfmajortext ? m = h.srfmajortext : i && h[i] ? m = h[i] : v && (m = `${v}${u + 1}`), r("div", {
          class: [e.e("header-item"), e.is("actived", u === a.active)],
          on: {
            click: () => n(u)
          }
        }, [r("div", {
          class: e.em("header-item", "title")
        }, [m]), a.enableDelete && r("div", {
          class: e.em("header-item", "delete"),
          attrs: {
            title: "移除"
          },
          on: {
            click: (E) => l(h, u, E)
          }
        }, [r("i", {
          class: "fa fa-close"
        })])]);
      }), a.enableCreate && r("div", {
        class: [e.e("header-item"), e.e("add")],
        attrs: {
          title: "添加"
        },
        on: {
          click: () => c()
        }
      }, [r("span", ["添加"]), r("i", {
        class: "fa fa-plus"
      })])]);
    };
    return L(() => a.form.isLoaded, (f, y) => {
      f !== y && f === !0 && a.loadData();
    }), {
      ns: e,
      rendertanHeader: g,
      renderTabs: () => a.contentCtrlData.map((f, y) => {
        var h;
        let i = null;
        const {
          form: v
        } = a.model;
        if (v && a.providers[v.name] && a.model.appEntity) {
          const u = Object.assign(a.form.context.clone(), {
            [(h = a.model.appEntity.codeName) == null ? void 0 : h.toLowerCase()]: f[a.model.appEntity.keyName]
          });
          i = r(a.providers[v.name].component, {
            props: {
              modelData: v,
              context: u,
              params: a.form.params,
              enableAutoSave: !0,
              silentVerify: !0
            },
            on: {
              neuronInit: a.onNeuronInit(f.srfkey)
            }
          });
        }
        return r("div", {
          class: [e.e("content"), e.is("actived", y === a.active)],
          key: f.srfkey
        }, [i]);
      })
    };
  },
  render() {
    return r("div", {
      class: this.ns.b()
    }, [this.rendertanHeader(), this.renderTabs()]);
  }
}), Me = _({
  name: "AutoSelectAll",
  props: te(),
  emits: H(),
  setup(s, {
    emit: e
  }) {
    const a = B("mpicker"), t = s.controller, l = b([]), n = b([]), c = b([]), g = b(!1), p = b(!1), f = b(null), y = b([]), i = V(() => {
      const D = t.editorParams.followitem;
      return D ? s.data[D] : "";
    });
    L(() => s.value, (D) => {
      l.value = [], c.value = [], D && (c.value = JSON.parse(D), c.value.length > 0 && c.value.forEach((w) => {
        n.value.findIndex((x) => Object.is(x.srfkey, w.srfkey)) < 0 && (n.value.push(w), y.value.push(w.srfmajortext)), l.value.push(w.srfkey);
      }));
    }, {
      immediate: !0,
      deep: !0
    });
    const v = async (D) => {
      const w = [];
      if (D && Array.isArray(D))
        for (let x = 0; x < D.length; x++) {
          const k = D[x], o = {
            srfkey: k[t.keyName] || k.srfkey,
            srfmajortext: k[t.textName] || k.srfmajortext
          }, d = await t.calcFillDataItems(k);
          d.length > 0 && d.forEach((F) => {
            Object.assign(o, {
              [F.name]: F.value
            });
          }), w.push(o), n.value.findIndex((F) => Object.is(F[t.keyName], k[t.keyName])) < 0 && n.value.push(o);
        }
      const I = w.length > 0 ? JSON.stringify(w) : "";
      e("change", I);
    }, h = async () => {
      let D;
      c.value.length && (D = JSON.stringify(c.value));
      const w = await t.openPickUpView(s.data, D);
      w && v(w);
    }, u = (D) => {
      const w = [];
      if (D.length > 0) {
        D.forEach((x) => {
          let k = n.value.findIndex((d) => Object.is(d.srfkey, x)), o = null;
          k >= 0 ? o = n.value[k] : (k = c.value.findIndex((d) => Object.is(d.srfkey, x)), k >= 0 && (o = c.value[k])), o && w.push(o);
        });
        const I = w.length > 0 ? JSON.stringify(w) : "";
        e("change", I);
      } else
        e("change", "");
    }, m = async (D) => {
      if (t.model.appDataEntity) {
        p.value = !0;
        try {
          const w = await t.getServiceData(D, s.data);
          p.value = !1, n.value = [], w.data.length > 0 && (n.value = w.data.map((I) => ({
            srfkey: I[t.keyName],
            srfmajortext: I[t.textName]
          })));
        } catch (w) {
          p.value = !1;
        }
      }
    }, E = (D) => {
      g.value = D, e("operate", D), g.value && m("");
    }, P = V(() => c.value.map((D) => D.srfmajortext).join("、")), S = (D) => {
      n.value = D;
    };
    return L(() => i.value, async (D) => {
      if (D) {
        await m("");
        const w = n.value.map((I) => I.srfkey);
        u(w);
      } else
        n.value = [], e("change", "");
    }, {
      immediate: !0
    }), {
      ns: a,
      c: t,
      selectRef: f,
      curValue: l,
      loading: p,
      items: n,
      defaultLabel: y,
      valueText: P,
      onSearch: m,
      onOpenChange: E,
      onSelect: u,
      openPickUpView: h,
      setDefaultOptions: S
    };
  },
  render(s) {
    return s("div", {
      class: [this.ns.b(), this.disabled ? this.ns.m("disabled") : "", this.readonly ? this.ns.m("readonly") : ""]
    }, [this.readonly && this.valueText, !this.readonly && s("iSelect", {
      ref: "selectRef",
      props: {
        ...this.c.customProps,
        value: this.curValue,
        filterable: !0,
        transfer: !0,
        multiple: !0,
        defaultLabel: this.defaultLabel,
        loading: this.loading,
        placeholder: this.c.placeHolder,
        disabled: this.disabled,
        remoteMethod: this.onSearch
      },
      on: {
        "on-change": this.onSelect,
        "on-open-change": this.onOpenChange
      }
    }, [this.items.map((e) => s("i-option", {
      key: e.srfkey,
      attrs: {
        value: e.srfkey,
        label: e.srfmajortext
      }
    }, [e.srfmajortext]))]), !this.readonly && s("div", {
      class: this.ns.e("buns-position")
    }, [s("div", {
      class: this.ns.e("btns")
    }, [this.c.pickupView ? s("i-button", {
      attrs: {
        icon: "ios-search",
        type: "text"
      },
      on: {
        click: this.openPickUpView
      }
    }) : null])])]);
  }
});
const Re = _({
  name: "MPickerCheckbox",
  props: te(),
  emits: H(),
  setup(s, {
    emit: e
  }) {
    const a = B("checkbox"), t = s.controller, l = b([]), n = b([]), c = ",", g = V({
      get() {
        var u;
        return ((u = s.value) == null ? void 0 : u.split(",")) || [];
      },
      set(u) {
        let m = null;
        const E = [];
        l.value.length > 0 && (l.value.forEach((P) => {
          u.findIndex((D) => Object.is(P.value, D)) !== -1 && E.push(P.value);
        }), m = E.join(c)), e("change", m);
      }
    }), p = async (u) => {
      const {
        context: m,
        params: E
      } = t.handlePublicParams(u, t.context, t.params);
      if (t.editorParams.codeTag) {
        let P = [];
        const S = t.editorParams.codeTag;
        return P = await ibiz.codeListService.get(S, m, E), P;
      }
      throw new he(t.model.source, "请配置代码表");
    }, f = (u) => {
      g.value = u;
    }, y = V(() => {
      const u = Array.isArray(g.value) ? g.value : [g.value];
      return l.value.filter((m) => u.includes(m.srfkey)).map((m) => m.srfmajortext).join("、");
    }), i = async (u) => {
      if (t.model.appDataEntity)
        try {
          const m = await t.getServiceData(u, s.data);
          n.value = [], m.data.length > 0 && (n.value = m.data.map((E) => ({
            srfkey: E[t.keyName],
            srfmajortext: E[t.textName]
          })));
        } catch (m) {
          console.error(m);
        }
    }, v = V(() => {
      const u = t.editorParams.followitem;
      return u ? s.data[u] : "";
    }), h = () => {
      const u = [];
      l.value.forEach((m) => {
        n.value.findIndex((P) => P.srfkey === m.value) > -1 && u.push(m.value);
      }), f(u);
    };
    return L(() => v, async (u) => {
      await p(u).then((m) => {
        l.value = m;
      }), await i(""), h();
    }, {
      immediate: !0,
      deep: !0
    }), {
      ns: a,
      c: t,
      valueText: y,
      selectArray: g,
      items: l,
      onSearch: i,
      onSelectArrayChange: f
    };
  },
  render(s) {
    return s("div", {
      class: [this.ns.b(), this.disabled ? this.ns.m("disabled") : "", this.readonly ? this.ns.m("readonly") : ""]
    }, [this.readonly && this.valueText, !this.readonly && s("ICheckboxGroup", {
      props: {
        ...this.c.customProps,
        value: this.selectArray
      },
      on: {
        "on-change": this.onSelectArrayChange
      }
    }, [this.items.map((e, a) => s("i-checkbox", {
      key: a,
      attrs: {
        label: e.value,
        disabled: this.disabled
      }
    }, [s("span", {
      class: this.ns.e("text")
    }, [e.text])]))])]);
  }
});
class Ue extends Pe {
  /**
   * 设置嵌入视图的神经元
   *
   * @author lxm
   * @date 2022-09-15 10:09:22
   * @param {ViewNeuron} neuron
   */
  setViewNeuron(e) {
    this.neuron = e, this.neuron.evt.on("refreshed", (a) => {
      if (ibiz.log.debug("接收到关系界面的刷新变更事件", a), this.model.formItemUpdate) {
        const { methodName: t, itemNames: l, model: n } = this.model.formItemUpdate;
        this.form.updateFormItem(
          t,
          l,
          n
        );
      }
    }), this.neuron.evt.on("mounted", () => {
      this.neuron.call.refresh();
    }), this.neuron.evt.on("viewDataChange", async (a) => {
      if (!["LOAD", "LOADDRAFT"].includes(a.type) && (ibiz.log.debug("接收到关系界面的数据变更事件", a.data), this.model.formItemUpdate)) {
        const { methodName: t, itemNames: l, model: n } = this.model.formItemUpdate;
        try {
          this.processState.formItemUpdate = !0, await this.form.updateFormItem(
            t,
            l,
            n
          );
        } finally {
          this.processState.formItemUpdate = !1;
        }
      }
    }), this.neuron.evt.on("destroyed", () => {
      Object.keys(this.processState).forEach((a) => {
        this.processState[a] = !1;
      });
    }), this.neuron.evt.on("viewSaveStart", () => {
      this.processState.viewSave = !0;
    }), this.neuron.evt.on("viewSaveEnd", () => {
      this.processState.viewSave = !1;
    });
  }
}
class Le {
  constructor() {
    C(this, "component", "IBizFormDataComparison");
  }
}
class Be extends Ce {
  async execAction(e, a, t, l) {
    const n = {}, c = e.getPSAppDataEntity();
    if (c) {
      c.isFill === !1 && await c.fill(!0);
      const g = new G(c);
      await g.init();
      const { resultContext: p } = await this.handleParams(
        e,
        a,
        t,
        l
      ), f = ibiz.resourcePathUtil.calcPaths(
        p,
        g.codeName
      ), y = q(p, f);
      let i = `${y}/${g.deNamePlural}/importtemplate`, v = `${y}/${g.deNamePlural}/importdata2`;
      const h = e.getPSAppDEDataImport();
      h && (i += `?srfimporttag=${h.codeName}`, v += `?srfimporttag=${h.codeName}`);
      const u = ibiz.overlay.createModal(
        "CustomDataImport",
        {
          templateUrl: i,
          importUrl: v,
          dismiss: (m) => {
            u.dismiss(m);
          }
        },
        {
          width: "auto",
          placement: "center"
        }
      );
      return u.present(), await u.onWillDismiss(), {
        refresh: !0
      };
    }
    return n;
  }
}
class _e {
  constructor() {
    C(this, "handler");
  }
  async getHandler() {
    return this.handler || (this.handler = new Be()), this.handler;
  }
}
class je {
  constructor() {
    C(this, "gridEditor", "YearMonthPicker");
    C(this, "formEditor", "YearMonthPicker");
  }
  async createController(e, a) {
    const t = new Ae(e, a);
    return await t.init(), t;
  }
}
class Ve {
  constructor() {
    C(this, "formEditor", "DownLoadSafeFile");
    C(this, "gridEditor", "DownLoadSafeFile");
  }
  async createController(e, a) {
    const t = new Fe(e, a);
    return await t.init(), t;
  }
}
class Ye extends se {
  async execAction(e, a, t, l, n) {
    const c = {}, { frontProcessType: g } = e;
    if (g === "OPENHTMLPAGE") {
      const p = ne.fill(e.htmlPageUrl, a, t == null ? void 0 : t[0]);
      window.open(p, "_blank");
    }
    if (g === "DATAIMP") {
      const p = e.getPSAppDataEntity();
      if (p) {
        p.isFill === !1 && await p.fill(!0);
        const f = new G(p);
        await f.init();
        const { resultContext: y } = await this.handleParams(
          e,
          a,
          t,
          l
        ), i = ibiz.resourcePathUtil.calcPaths(
          y,
          f.codeName
        ), v = q(y, i);
        let h = `${v}/${f.deNamePlural}/importtemplate`, u = `${v}/${f.deNamePlural}/importdata2`;
        const m = e.getPSAppDEDataImport();
        m && (h += `?srfimporttag=${m.codeName}`, u += `?srfimporttag=${m.codeName}`);
        const E = ibiz.overlay.createModal(
          "DataImport",
          {
            templateUrl: h,
            importUrl: u,
            dismiss: (P) => {
              E.dismiss(P);
            }
          },
          {
            width: "auto",
            placement: "center"
          }
        );
        return E.present(), await E.onWillDismiss(), {
          refresh: !0
        };
      }
    }
    if (["TOP", "WIZARD"].includes(g)) {
      const p = e.getFrontPSAppView();
      if (!p)
        throw new Error("未配置打开视图");
      await p.fill(!0);
      const { resultContext: f, resultParams: y } = await this.handleParams(
        e,
        a,
        t,
        l
      ), i = await ibiz.commands.execute(
        re.TAG,
        p,
        f,
        y,
        n
      );
      (i == null ? void 0 : i.ok) === !1 && (c.closeView = !1, c.refresh = !1, c.cancel = !0), i != null && i.ok && i.data && (c.data = i.data);
    } else if (n) {
      const { neuron: p } = n, y = p.call.getFormController().call.getFormController(), { druipart1: i, druipart2: v, druipart3: h } = y.details;
      [
        {
          message: "服务履历为空",
          neuron: i
        },
        {
          message: "教育经验为空",
          neuron: v
        },
        {
          message: "项目经验为空",
          neuron: h
        }
      ].some((E) => {
        const P = E.neuron.neuron.call.getGridController();
        if (P) {
          const S = P.call.getGridController();
          if (S && S.items && S.items.length > 0)
            return !1;
        }
        return ibiz.message.error(`${E.message}`, 1.5, !0), !0;
      }) || await p.call.wfStart();
    }
    return c;
  }
}
class ze {
  constructor() {
    C(this, "handler");
  }
  async getHandler() {
    return this.handler || (this.handler = new Ye()), this.handler;
  }
}
class $e {
  constructor() {
    C(this, "component", "FormMDCtrlFormStyle2");
  }
  async createController(e, a, t) {
    const l = new le(e, a, t);
    return await l.init(), l;
  }
}
class Ge {
  constructor() {
    C(this, "formEditor", "AutoSelectAll");
    C(this, "gridEditor", "AutoSelectAll");
  }
  async createController(e, a) {
    const t = new oe(e, a);
    return await t.init(), t;
  }
}
class He {
  constructor() {
    C(this, "formEditor", "MPickerCheckbox");
    C(this, "gridEditor", "IBizGridPicker");
  }
  async createController(e, a) {
    const t = new oe(e, a);
    return await t.init(), t;
  }
}
class qe extends se {
  async execAction(e, a, t, l, n) {
    const c = {}, { frontProcessType: g } = e;
    if (g === "OPENHTMLPAGE") {
      const p = ne.fill(e.htmlPageUrl, a, t == null ? void 0 : t[0]);
      window.open(p, "_blank");
    }
    if (g === "DATAIMP") {
      const p = e.getPSAppDataEntity();
      if (p) {
        p.isFill === !1 && await p.fill(!0);
        const f = new G(p);
        await f.init();
        const { resultContext: y } = await this.handleParams(
          e,
          a,
          t,
          l
        ), i = ibiz.resourcePathUtil.calcPaths(
          y,
          f.codeName
        ), v = q(y, i);
        let h = `${v}/${f.deNamePlural}/importtemplate`, u = `${v}/${f.deNamePlural}/importdata2`;
        const m = e.getPSAppDEDataImport();
        m && (h += `?srfimporttag=${m.codeName}`, u += `?srfimporttag=${m.codeName}`);
        const E = ibiz.overlay.createModal(
          "DataImport",
          {
            templateUrl: h,
            importUrl: u,
            dismiss: (P) => {
              E.dismiss(P);
            }
          },
          {
            width: "auto",
            placement: "center"
          }
        );
        return E.present(), await E.onWillDismiss(), {
          refresh: !0
        };
      }
    }
    if (["TOP", "WIZARD"].includes(g)) {
      const p = e.getFrontPSAppView();
      if (!p)
        throw new Error("未配置打开视图");
      await p.fill(!0);
      const { resultContext: f, resultParams: y } = await this.handleParams(
        e,
        a,
        t,
        l
      ), i = await ibiz.commands.execute(
        re.TAG,
        p,
        f,
        y,
        n
      );
      (i == null ? void 0 : i.ok) === !1 && (c.closeView = !1, c.refresh = !1, c.cancel = !0), i != null && i.ok && i.data && (c.data = i.data);
    } else if (t && t.length > 0 && n) {
      const { neuron: p } = n, i = await p.call.getFormController().call.getFormController().autoSave();
      i && i.rcryqd && Array.isArray(i.rcryqd) && i.rcryqd.length > 0 ? await p.call.wfStart() : ibiz.message.error("入场信息为空");
    }
    return c;
  }
}
class Ke {
  constructor() {
    C(this, "handler");
  }
  async getHandler() {
    return this.handler || (this.handler = new qe()), this.handler;
  }
}
class Je {
  constructor() {
    C(this, "component", "FormDruipart");
  }
  async createController(e, a, t) {
    const l = new Ue(e, a, t);
    return await l.init(), l;
  }
}
const nt = {
  mateUrl: import.meta.url,
  install(s) {
    ie.loadStyle(["/style.css"]), s.component("IBizFormDataComparison", Se), s.component("CustomDataImport", xe), s.component("YearMonthPicker", Ne), s.component("DownLoadSafeFile", Oe), s.component("FormMDCtrlFormStyle2", Te), s.component("AutoSelectAll", Me), s.component("MPickerCheckbox", Re), ibiz.register.control.register(
      "EDITFORM_RENDER_FORM_DATA_COMPARISON",
      new Le()
    ), ibiz.register.uiAction.register(
      "DEUIACTION_CUSTOM_IMPORT",
      new _e()
    ), ibiz.register.editor.register(
      "DATEPICKEREX_NOTIME_YEAR_MONTH_PICKER",
      new je()
    ), ibiz.register.editor.register(
      "FILEUPLOADER_ONE_DOWNLOAD_FILE",
      new Ve()
    ), ibiz.register.uiAction.register(
      "DEUIACTION_JUDEG_ENABLE_UPDATE",
      new ze()
    ), ibiz.register.formDetail.register(
      "FORM_USERCONTROL_MUL_FORM_CARD",
      new $e()
    ), ibiz.register.editor.register(
      "EDITOR_CUSTOMSTYLE_AUTO_SELECT_ALL",
      new Ge()
    ), ibiz.register.editor.register(
      "EDITOR_CUSTOMSTYLE_MULTIPLE_CHECKBOX",
      new He()
    ), ibiz.register.uiAction.register(
      "DEUIACTION_check_rcxx",
      new Ke()
    ), ibiz.register.formDetail.register(
      "FORM_USERCONTROL_DRUIPART_ENABLEINITLOAD",
      new Je()
    );
  }
};
export {
  nt as default
};
